'use strict';function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$1 = {
  name: "Draggable",
  props: {
    classOnDrag: String,
    payload: {
      type: Object,
      default: {}
    }
  },
  emits: ["startDrag", "endDrag"],
  data: function data() {
    return {
      dragInProgress: false,
      isInvisible: false,
      originalPosition: {}
    };
  },
  computed: {
    elementWidth: function elementWidth() {
      return this.$refs.draggable.offsetWidth;
    },
    elementHeight: function elementHeight() {
      return this.$refs.draggable.offsetHeight;
    }
  },
  methods: {
    setOriginalPosition: function setOriginalPosition() {
      this.originalPosition.left = this.$refs.draggable.offsetLeft;
      this.originalPosition.top = this.$refs.draggable.offsetTop;
    },
    startDrag: function startDrag(event) {
      var _this = this;

      if (event.dataTransfer) {
        setTimeout(function () {
          _this.isInvisible = true;
        }, 0);
        this.dragInProgress = true;
        event.dataTransfer.dropEffect = "move";
        event.dataTransfer.effectAllowed = "move";
        event.dataTransfer.setData("payload", JSON.stringify(this.payload));
      }

      this.$emit("startDrag", this.payload);
    },
    endDrag: function endDrag() {
      this.isInvisible = false;
      this.dragInProgress = false;
      this.$emit("endDrag", this.payload);
    },
    setElementPosition: function setElementPosition(top, left) {
      this.$refs.draggable.style.top = top;
      this.$refs.draggable.style.left = left;
    },
    touchStart: function touchStart(event) {
      this.dragInProgress = true;
      this.$refs.draggable.style.position = "relative";
      this.startDrag(event);
    },
    touchMove: function touchMove(event) {
      if (!event.targetTouches) return;
      if (event.targetTouches.length !== 1) return;
      var touchLocation = event.targetTouches[0];
      this.setElementPosition(touchLocation.pageY - this.elementHeight / 2 - (this.originalPosition.top || 0) + "px", touchLocation.pageX - this.elementWidth / 2 - (this.originalPosition.left || 0) + "px");
    },
    touchEnd: function touchEnd(event) {
      this.dragInProgress = false;
      this.$refs.draggable.style.position = "static";
      if (this.originalPosition.left !== undefined && this.originalPosition.top !== undefined) this.setElementPosition(this.originalPosition.top, this.originalPosition.left);
      if (!event.changedTouches || event.changedTouches.length !== 1) return;
      var payload = this.payload;
      var touchLocation = event.changedTouches[0];
      var x = touchLocation.pageX;
      var y = touchLocation.pageY;
      var detail = {
        position: {
          x: x,
          y: y
        },
        payload: payload
      };
      var dropEvent = new CustomEvent("MobileDrop", {
        detail: detail
      });
      document.dispatchEvent(dropEvent);
      this.endDrag();
    }
  },
  mounted: function mounted() {
    this.setOriginalPosition();
    window.addEventListener("resize", this.setOriginalPosition);
  },
  unmounted: function unmounted() {
    window.removeEventListener("resize");
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}/* script */
var __vue_script__$1 = script$1;
/* template */

var __vue_render__$1 = function __vue_render__() {
  var _obj;

  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', _vm._b({
    ref: "draggable",
    class: (_obj = {}, _obj[_vm.classOnDrag] = _vm.dragInProgress, _obj),
    staticStyle: {
      "position": "relative"
    },
    style: {
      display: _vm.isInvisible ? 'none' : 'inherit'
    },
    attrs: {
      "draggable": "",
      "drag-in-progress": _vm.dragInProgress
    },
    on: {
      "dragstart": _vm.startDrag,
      "dragend": _vm.endDrag,
      "touchstart": _vm.touchStart,
      "touchend": _vm.touchEnd,
      "touchmove": _vm.touchMove
    }
  }, 'div', _vm.$attrs, false), [_vm._t("default")], 2);
};

var __vue_staticRenderFns__$1 = [];
/* style */

var __vue_inject_styles__$1 = undefined;
/* scoped */

var __vue_scope_id__$1 = undefined;
/* module identifier */

var __vue_module_identifier__$1 = "data-v-2761f4fa";
/* functional template */

var __vue_is_functional_template__$1 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$1,
  staticRenderFns: __vue_staticRenderFns__$1
}, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, undefined, undefined, undefined);

var __vue_component__$3 = __vue_component__$2;//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: "Dropable",
  emits: ["onDrop"],
  data: function data() {
    return {
      eventListener: null
    };
  },
  computed: {
    left: function left() {
      return this.$refs.dropable.offsetLeft;
    },
    right: function right() {
      return this.$refs.dropable.offsetLeft + this.$refs.dropable.offsetWidth;
    },
    top: function top() {
      return this.$refs.dropable.offsetTop;
    },
    bottom: function bottom() {
      return this.$refs.dropable.offsetTop + this.$refs.dropable.offsetHeight;
    }
  },
  methods: {
    dropHandler: function dropHandler(event) {
      event.preventDefault();
      var payload = JSON.parse(event.dataTransfer.getData("payload"));
      this.$emit("onDrop", payload);
    },
    areCoordinatesInElement: function areCoordinatesInElement(x, y) {
      var horizontal = x > this.left && x < this.right;
      var vertical = y > this.top && y < this.bottom;
      return horizontal && vertical;
    },
    registerEventListener: function registerEventListener() {
      var vm = this;
      this.eventListener = document.addEventListener("MobileDrop", function (dropEvent) {
        if (!dropEvent.detail || !dropEvent.detail.position) return;
        var _dropEvent$detail$pos = dropEvent.detail.position,
            x = _dropEvent$detail$pos.x,
            y = _dropEvent$detail$pos.y;
        if (!vm.areCoordinatesInElement(x, y)) return;
        vm.$emit("onDrop", dropEvent.detail.payload);
      });
    }
  },
  mounted: function mounted() {
    this.registerEventListener();
  },
  unmounted: function unmounted() {
    if (this.eventListener) document.removeEventListener(this.eventListener);
  }
};/* script */
var __vue_script__ = script;
/* template */

var __vue_render__ = function __vue_render__() {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', _vm._b({
    ref: "dropable",
    attrs: {
      "id": "drop-handler"
    },
    on: {
      "drop": _vm.dropHandler,
      "dragenter": function dragenter($event) {
        $event.preventDefault();
      },
      "dragover": function dragover($event) {
        $event.preventDefault();
      }
    }
  }, 'div', _vm.$attrs, false), [_vm._t("default")], 2);
};

var __vue_staticRenderFns__ = [];
/* style */

var __vue_inject_styles__ = undefined;
/* scoped */

var __vue_scope_id__ = undefined;
/* module identifier */

var __vue_module_identifier__ = "data-v-475d85b2";
/* functional template */

var __vue_is_functional_template__ = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, undefined, undefined, undefined);

var __vue_component__$1 = __vue_component__;/* eslint-disable import/prefer-default-export */var components$1=/*#__PURE__*/Object.freeze({__proto__:null,Draggable:__vue_component__$3,Dropable:__vue_component__$1});var install = function installVueCrossPlatformDragDrop(Vue) {
  Object.entries(components$1).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        componentName = _ref2[0],
        component = _ref2[1];

    Vue.component(componentName, component);
  });
}; // Create module definition for Vue.use()
var components=/*#__PURE__*/Object.freeze({__proto__:null,'default':install,Draggable:__vue_component__$3,Dropable:__vue_component__$1});// only expose one global var, with component exports exposed as properties of
// that global var (eg. plugin.component)

Object.entries(components).forEach(function (_ref) {
  var _ref2 = _slicedToArray(_ref, 2),
      componentName = _ref2[0],
      component = _ref2[1];

  if (componentName !== 'default') {
    install[componentName] = component;
  }
});module.exports=install;